<template>
    <v-row>
        <v-col>
            <data-table
                v-model="items"
                :title="$t('revenue')"
                endpoint="api/revenue"
                :filters="filters"
                :headers="headers"
                :search-label="searchLabel"
            >
                <template v-slot:buttons>
                    <download-excel
                        :data="items"
                        :fields="excelFields"
                        :name="excelName"
                        type="xls"
                    >
                        <v-btn class="primary">
                            <v-icon>mdi-download</v-icon>
                            {{ $t('excel') }}
                        </v-btn>
                    </download-excel>
                </template>

                <template v-slot:filters="{ filters , confirmed }">
                    <revenue-filters
                        :dates.sync="filters.date"
                        @confirmed="confirmed"
                    ></revenue-filters>
                </template>

                <template v-slot:item="{ item }">
                    <tr>
                        <td>{{ item.profile.name }}</td>
                        <td>{{ item.email }}</td>
                        <td>{{ item.stripe_id }}</td>
                        <td>{{ item.total_success_amount | currency }} <span class="text-uppercase">{{ item.currency }}</span></td>
                        <td>{{ item.total_amount_refunded | currency }} <span class="text-uppercase">{{ item.currency }}</span></td>
                        <td>{{ item.total_revenue | currency }} <span class="text-uppercase">{{ item.currency }}</span></td>
                    </tr>
                </template>
            </data-table>
        </v-col>
    </v-row>
</template>

<script>
    import DataTable from "../DataTable";
    import util from "../../../mixins/util";
    import RevenueFilters from "../filters/RevenueFilters";
    import moment from "moment";

    export default {
        name: "Revenue",
        components: {RevenueFilters, DataTable},
        mixins: [ util ],
        data: () => ({
            filters: {
                date: []
            },
            items: []
        }),

        computed: {
            excelFields() {
                return {
                    'Name': 'profile.name',
                    'Email': 'email',
                    'Customer Stripe': 'stripe_id',
                    'Total Success Amount': 'total_success_amount',
                    'Total Amount Refunded' : 'total_amount_refunded',
                    'Total Revenue' : 'total_revenue'
                }
            },

            excelName() {
                let currentTime = moment().format('YYYY_MM_DD');
                return 'Subscription_'+currentTime+'.xls';
            },
            headers() {
                return [
                    { text: this.$t('name'), value: 'name' },
                    { text: this.$t('email'), value: 'email' },
                    { text: this.$t('customer_stripe'), value: 'stripe_id' },
                    { text: this.$t('total_success_amount'), value: 'total_success_amount'},
                    { text: this.$t('total_amount_refunded'), value: 'total_amount_refunded'},
                    { text: this.$t('total_revenue'), value: 'total_revenue'}
                ]
            },

            searchLabel() {
                return this.$t('search_using', {
                    field: this.$t('name')
                })
            }
        }
    }
</script>

<style scoped>
</style>
